<template>
    <div class="visual-oscillator">
      <div class="oscillator-type">
        <div>Type:</div>
        <div>({{nodeInfos.type}})</div>
        <input type="range" min="0" max="3" value="selectedWaveForm" @change="handleTypeChange" />
      </div>        
      <div class="oscillator-frequency">
        <div>Frequency:</div>
        <input type="range" min="0" max="1000" v-model="nodeInfos.frequency.value" />
      </div>
    </div>
</template>

<script type="ts">
    import { defineComponent } from 'vue'

    const waveForms = ['sine', 'triangle', 'square', 'sawtooth'];

    export default defineComponent({
        name: "VisualOscillator",
        props: {
          nodeInfos: OscillatorNode
        },
        data() {
          return {
            selectedWaveForm: waveForms.indexOf(this.nodeInfos.type)
          };
        },
        methods: {
          handleTypeChange(e) {
            this.selectedWaveForm = waveForms[e.target.value];
            this.nodeInfos.type = this.selectedWaveForm
          },
          handleFreqChange(e) {
            this.nodeInfos.frequency = e.target.value
          },
        }
    })
</script>

<style>
.visual-oscillator {
  display: flex;
  flex-direction: column;
}

.oscillator-type, .oscillator-frequency {
  display: flex;
  gap: 4px;
}
</style>
